#include <amxmodx>
#include <cstrike>

/**
uc_adminmode & uc_playermode:
a = The dead can see the chat messages of their alive teammates non-teammessages.
b = The dead can see the chat messages of their alive non-teammates non-teammessages.
c = The alive can see the chat messages of their dead teammates non-teammessages.
d = The alive can see the chat messages of their dead non-teammates non-teammessages

e = The dead can see the chat messages of their alive teammates teammessages
f = The alive can see the chat messages of their dead teammates teammessages
g = The dead can see the chat messages of their dead non-teammates teammessages
h = The alive can see the chat messages of their alive non-teammates teammessages
i = The dead can see the chat messages of their alive non-teammates teammessages
j = The alive can see the chat messages of their dead non-teammates teammessages

Default cvar values:
uc_enabled "1"
uc_adminmode "abcdefghij"
uc_playermode "abe"
uc_adminflag "n"
**/

/**
 * Support for auto updating. If you want to enable, just download and install HTTP:X. Everything else is automatic.
 * https://forums.alliedmods.net/showthread.php?t=282949
**/
native HTTPX_Download(const URL[], const Filename[] = "", const CompleteHandler[] = "", const ProgressHandler[] = "", Port = 0, RequestType = 0, const Username[] = "", const Password[] = "", ... /* For possible future use */)
native HTTPX_GetData(data[], len)



new const VersionNum = 152;

new gSayText;

new gpcvarEnabled,
	gpcvarAdminMode,
	gpcvarPlayerMode,
	gpcvarAdminFlag;

new const gTextChannels[][] = {
	"#Cstrike_Chat_All",
	"#Cstrike_Chat_AllDead",
	"#Cstrike_Chat_T",
	"#Cstrike_Chat_T_Dead",
	"#Cstrike_Chat_CT",
	"#Cstrike_Chat_CT_Dead",
	"#Cstrike_Chat_Spec",
	"#Cstrike_Chat_AllSpec"
};

public plugin_init() {

	new temp[5];
	num_to_str(VersionNum, temp[1], charsmax(temp));
	temp[0] = temp[1];
	temp[1] = '.';
	
	register_plugin("Ultimate Chat", temp, "[ --{-@ ]");
	
	gpcvarEnabled = register_cvar("uc_enabled", "1");
	gpcvarAdminMode = register_cvar("uc_adminmode", "abcdefghij");
	gpcvarPlayerMode = register_cvar("uc_playermode", "abe");
	gpcvarAdminFlag = register_cvar("uc_adminflag", "n");
	
	gSayText = get_user_msgid("SayText");
	
	set_task(1.0, "PlaceUCLastInQue");

	UpdatePlugin();
}

public PlaceUCLastInQue() {
	register_clcmd("say", "HandleSay");
	register_clcmd("say_team", "HandleSay");
}

public HandleSay(id) {
	
	if ( ! get_pcvar_num(gpcvarEnabled) )
		return PLUGIN_CONTINUE;
	
	if ( ! is_user_connected(id) )
		return PLUGIN_CONTINUE;
	
	new bool:SenderAlive = is_user_alive(id) ? true : false;
	new ReceiverFlags, ReceiverAlive, bool:ReceiverAdmin;
	static Text[192];
	
	read_argv(0, Text, charsmax(Text));
	new TeamMsg = Text[3] == '_';
	
	get_pcvar_string(gpcvarPlayerMode, Text, charsmax(Text));
	new PlayerMode = read_flags(Text);
	
	get_pcvar_string(gpcvarAdminMode, Text, charsmax(Text));
	new AdminMode = read_flags(Text);
	
	get_pcvar_string(gpcvarAdminFlag, Text, charsmax(Text));
	new AdminFlags = read_flags(Text);
	
	new CsTeams:ReceiverTeam, CsTeams:SenderTeam = cs_get_user_team(id);
	
	read_args(Text, charsmax(Text));
	remove_quotes(Text);
	trim(Text);
	
	if ( ! Text[0] )
		return PLUGIN_HANDLED;
	
	new Players[32], PlayersNum, tempPlayer;
	get_players(Players, PlayersNum, "c");
	
	for ( new i ; i < PlayersNum ; i++ ) {
		
		tempPlayer = Players[i];
		
		ReceiverFlags = get_user_flags(tempPlayer);
		ReceiverAdmin = AdminFlags & ReceiverFlags || ( AdminFlags & ADMIN_ADMIN && ReceiverFlags ) || AdminFlags == ADMIN_USER;
		ReceiverAlive = is_user_alive(tempPlayer);
		ReceiverTeam = cs_get_user_team(tempPlayer);
		if (
		( ( ( AdminMode & (1<< 0) && ReceiverAdmin ) || PlayerMode & (1<< 0) ) && ! TeamMsg &&   SenderAlive && ! ReceiverAlive && SenderTeam == ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 1) && ReceiverAdmin ) || PlayerMode & (1<< 1) ) && ! TeamMsg &&   SenderAlive && ! ReceiverAlive && SenderTeam != ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 2) && ReceiverAdmin ) || PlayerMode & (1<< 2) ) && ! TeamMsg && ! SenderAlive &&   ReceiverAlive && SenderTeam == ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 3) && ReceiverAdmin ) || PlayerMode & (1<< 3) ) && ! TeamMsg && ! SenderAlive &&   ReceiverAlive && SenderTeam != ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 4) && ReceiverAdmin ) || PlayerMode & (1<< 4) ) &&   TeamMsg &&   SenderAlive && ! ReceiverAlive && SenderTeam == ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 5) && ReceiverAdmin ) || PlayerMode & (1<< 5) ) &&   TeamMsg && ! SenderAlive &&   ReceiverAlive && SenderTeam == ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 6) && ReceiverAdmin ) || PlayerMode & (1<< 6) ) &&   TeamMsg && ! SenderAlive && ! ReceiverAlive && SenderTeam != ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 7) && ReceiverAdmin ) || PlayerMode & (1<< 7) ) &&   TeamMsg &&   SenderAlive &&   ReceiverAlive && SenderTeam != ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 8) && ReceiverAdmin ) || PlayerMode & (1<< 8) ) &&   TeamMsg &&   SenderAlive && ! ReceiverAlive && SenderTeam != ReceiverTeam ) ||
		( ( ( AdminMode & (1<< 9) && ReceiverAdmin ) || PlayerMode & (1<< 9) ) &&   TeamMsg && ! SenderAlive &&   ReceiverAlive && SenderTeam != ReceiverTeam )
		) {
			emessage_begin(MSG_ONE_UNRELIABLE, gSayText, {0,0,0}, tempPlayer);
			ewrite_byte(id);
			ewrite_string(gTextChannels[get_user_text_channel(id, SenderTeam, TeamMsg)]);
			ewrite_string("");
			ewrite_string(Text);
			emessage_end();
		}
	}
	
	return PLUGIN_CONTINUE;
}

stock get_user_text_channel(id, CsTeams:SenderTeam, TeamMsg) {
	if ( TeamMsg ) {
		switch ( SenderTeam ) {
			case CS_TEAM_T : {
				if ( is_user_alive(id) )
					return 2;
				else
					return 3;
			}
			case CS_TEAM_CT : {
				if ( is_user_alive(id) )
					return 4;
				else
					return 5;
			}
			default :
				return 6;
		}
	}
	
	if ( is_user_alive(id) )
		return 0;
	else if ( SenderTeam == CS_TEAM_SPECTATOR )
		return 7;
	
	return 1;
}


/*
if ( callfunc_begin("AutoupdatePlugin", "httpx.amxx") == 1 ) {
		callfunc_push_int(get_plugin(-1));
		callfunc_push_str("131277", false);
		callfunc_push_int(0);
		callfunc_end();
	}
*/

new gHTTPX = true;

UpdatePlugin() {
	
	if ( ! gHTTPX )
		return;

	new Temp[3];
	get_cvar_string("httpx_autoupdate", Temp, charsmax(Temp));

	if ( ! ( read_flags(Temp) & 2 ) )
		return;

	HTTPX_Download("digitaldecay.eu/forums/AM/UltimateChat/uc_version.txt", "", "forwardVersionCheck", "", 80, 0, "", "", 0, -1);
}

public forwardVersionCheck(DownloadID, Error) {

	if ( Error )
		return;

	new Data[4];
	HTTPX_GetData(Data, charsmax(Data));
	
	if ( VersionNum >= str_to_num(Data) )
		return;

	new hHTTPX = is_plugin_loaded("HTTP:X");

	if ( ! hHTTPX )
		return;

	new Filename[16];
	get_plugin(hHTTPX, Filename, charsmax(Filename));

	if ( callfunc_begin("AutoupdatePlugin", Filename) == 1 ) {
		callfunc_push_int(get_plugin(-1));
		callfunc_push_str("131277", false);
		callfunc_push_int(0);
		callfunc_end();
	}
}

public plugin_natives()
	set_native_filter("forwardNativeFilter");

public forwardNativeFilter(const Native[], Index, Trap) {
	
	if ( Trap )
		return PLUGIN_CONTINUE;

	if ( equal(Native, "HTTPX_Download") || equal(Native, "HTTPX_GetData") ) {
		gHTTPX = false;
		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}
